#Creating Views
#Database Used: SAKILA

#All columns from a table
SELECT *
FROM RENTAL
LIMIT 12;


#Certain Column names
SELECT INVENTORY_ID,CUSTOMER_ID,RETURN_DATE
FROM RENTAL
LIMIT 12;


#where
SELECT INVENTORY_ID,CUSTOMER_ID,RETURN_DATE
FROM RENTAL
WHERE CUSTOMER_ID =459;


#where with subquery
SELECT *
FROM PAYMENT
WHERE AMOUNT >=2.99 
AND CUSTOMER_ID = 1
AND RENTAL_ID IN (SELECT rental_id from RENTAL);


#select with aggregate functions
SELECT AVG(AMOUNT),CUSTOMER_ID
FROM PAYMENT
GROUP BY CUSTOMER_ID;


#Select with Having clause
SELECT C.CUSTOMER_ID,C.FIRST_NAME,C.LAST_NAME
FROM PAYMENT P,CUSTOMER C
WHERE P.CUSTOMER_ID = C.CUSTOMER_ID
GROUP BY C.CUSTOMER_ID
HAVING AVG(P.AMOUNT) > 3
LIMIT 20;


# SELECT in aggregate functions
SELECT P.CUSTOMER_ID,FIRST_NAME,LAST_NAME,EMAIL
FROM PAYMENT P,CUSTOMER C
WHERE P.CUSTOMER_ID=P.CUSTOMER_ID
GROUP BY C.CUSTOMER_ID
HAVING MAX(P.AMOUNT) > (SELECT AVG(AMOUNT) FROM PAYMENT)
LIMIT 20;

#SELECT in JOIN
SELECT S1.STORE_ID, S2.SALES 
FROM STORE S1
JOIN (
	SELECT CUS.STORE_ID, SUM(PAY.AMOUNT) SALES
	FROM CUSTOMER CUS
	JOIN PAYMENT PAY
	ON PAY.CUSTOMER_ID = CUS.CUSTOMER_ID
    GROUP BY CUS.STORE_ID
  ) S2
ON S1.STORE_ID = S2.STORE_ID
ORDER BY S1.STORE_ID;


#SELECT with functions like ROW_NUMBER
select ROW_NUMBER() OVER (ORDER BY AMOUNT DESC) CUSTOMER_ID, AMOUNT
FROM PAYMENT
LIMIT 10;


#SELECT in View
CREATE VIEW DOCUMENTARY_FILM_LIST AS 
SELECT F.TITLE,F.DESCRIPTION,F.LENGTH,F.RATING,GROUP_CONCAT(CONCAT(A.FIRST_NAME,A.LAST_NAME) SEPARATOR ', ') AS `ACTORS`
FROM FILM_ACTOR FA, FILM F ,ACTOR A
WHERE F.FILM_ID = FA.FILM_ID 
AND A.ACTOR_ID = FA.ACTOR_ID
AND F.FILM_ID IN (
SELECT FILM_ID FROM FILM_CATEGORY, CATEGORY
WHERE CATEGORY.CATEGORY_ID = FILM_CATEGORY.CATEGORY_ID
AND CATEGORY.CATEGORY_ID = 6)
GROUP BY F.FILM_ID;

SELECT * FROM DOCUMENTARY_FILM_LIST;